var datetime = require( './datetime' );

module.exports = {

  author_link: function ( author ) {
    return '<a href="/authors/' + author.url + '">' + author.name + '</a>';
  },

  byline: function ( post, authors ) {
    var line = 'By ';
    for ( var i = 0, l = post.authors.length; i < l; i++ ) {
      if ( i > 0 ) {
        if ( i === ( l - 1 ) ) {
          line += ( l === 2 ) ? ' and ' : ', and ';
        } else {
          line += ', ';
        }
      }

      line += this.author_link( authors[ post.authors[ i ] ] );
    }
    return line;
  },

  tag_link: function ( tag ) {
    return '<a href="/tags/' + tag.url + '">' + tag.title + '</a>';
  },

  tagline: function ( post, tags ) {
    var line = '';
    for ( var i = 0, l = post.tags.length; i < l; i++ ) {
      if ( i > 0 ) {
        line += ', ';
      }
      line += this.tag_link( tags[ post.tags[ i ] ] );
    }
    return line;
  },

  older_page_url: function ( page ) {
    return '/page/' + ( page + 1 );
  },

  newer_page_url: function ( page ) {
    var r = '/page/' + ( page - 1 );
    if ( page <= 2 ) {
      r = '/';
    }
    return r;
  },

  post_url: function ( post ) {
    var ymd = this.ymd( post.pubdate );
    return '/' + ymd + '/' + post.url;
  },

  formatDate: function ( d, format ) {
    d = new Date( d );
    return datetime.strftime( d, format );
  },

  ymd: function ( d ) {
    return this.formatDate( d, '%Y-%m-%d' );
  },

  snippet: function ( body, paragraphs ) {
    body = body.split( '</p>' );
    body = body.slice( 0, ( paragraphs || 2 ) ).join( '</p>' );
    return body + '</p>';
  }
};

